//+------------------------------------------------------------------+
//|                                                   Ballistika.mq4 |
//|                                   Copyright  2007,Sartakov S.D. |
//|                                    http://forum.mql4.com/ru/8744 |
//+------------------------------------------------------------------+
/*
ballistika  04.10.2007 13:54

  " -     ".,       ,      .,    .     -   .   . (  ).  "9-  1945-         . ()      " - . - "

    (     )     (       ,  -  ). - .

... -,
    .
    ,
   ...
... -,
    .
    ,
   ...
... -.
,     .
   ,
   ...
... -,
 -
   ,
 -     ...
... -,
 -,
  -,
  -..
...  ,
 -,
    ,
  -...
  -,
    .
   ,
 ,  ...



*/
#property copyright "Copyright  2007,Sartakov S.D."
#property link      "mailto:ssd@dp.ukrtel.net"
#include <stderror.mqh>
#include <stdlib.mqh>
#include <WinUser32.mqh>
//+------------------------------------------------------------------+
int _ExpertOrdersTotal = 0;    //  ,  :
int _ExpertOrdersOpen  = 0;    //    ,  :
int _ExpertOrdersStop  = 0;    //  (OP_BUYSTOP, OP_SELLSTOP),  :
// ,           :
int      _OrderTicket[], _OrderType[];
double   _OrderLots[], _OrderOpenPrice[], _OrderStopLoss[], _OrderTakeProfit[];
double   _OrderProfit[], _OrderSwap[], _OrderCommission[];
datetime _OrderOpenTime[], _OrderExpiration[];
string   _OrderComment[];

string OrderTypeString      = "BUY"; //BUY, SELL, BUYSTOP, SELLSTOP
string Bl = "                                                                                                                          ";
string OrderOpenSetOkMes    = "  -  "; 
string OrderOpenSetErrorMes = "  -   ";  

string OrderModifyOkMes     = "  -  ";   
string OrderModifyErrorMes  = "  -   "; 

string OrderDeleteOkMes     = "  -  "; 
string OrderDeleteErrorMes  = "  -   "; 

extern bool   NewTradeCycleAllowed = true;//         
extern double OrderLotsSize =0.1  ;       //    
extern int    OrderLevel    = 15  ;       //     OP_BUYSTOP, OP_SELLSTOP 
                                          //   OrderLevel*Point    Ask -  OP_BUYSTOP,   Bid -  OP_SELLSTOP 
extern int    StopLoss=30; //   
extern int    TrailingStop=30; //  
extern int    TrailingStep=3;               //   -   ,                                                   
extern int    MagicNumber = 1951;         //   ...

int Spread;                               //    
int OrderDirection;                       //+1 /  OP_BUYSTOP, -1  /  OP_SELLSTOP 
                                          //+1    OP_BUY,-1    OP_SELL
int LastError;                            
int i,j,k;
//---------------------------------------------------------------------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   Spread  = MarketInfo(Symbol(),MODE_SPREAD);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   AllOrdersInit(MagicNumber);       //    ....
// :      ,        ,
//          ,        ...

//      OP_BUYSTOP  OP_SELLSTOP
   if (OrdersOpenSet()) return(0);   //   ,  -  ,     ,  
// ,   : 
// -  -   
// -       -  
   if (OrdersModify())  return(0);   //   ,  -  ,     ,  
//       ,  NewTradeCycleAllowed = false,
//        ,    ,   ,      ...
   if (OrdersDelete())  return(0);   //   ,  -  ,     ,  

//----
   return(0); //   
  }
//+---------------------------------------------------------------------------------------------------------------+
  
//+---------------------------------------------------------------------------------------------------------------+
//|     OP_BUYSTOP,OP_SELLSTOP      :|
//  -                                                             |
//  -       ,      ,    |
//     ,         -              |
//       -             |
//+---------------------------------------------------------------------------------------------------------------+
bool OrdersOpenSet()   // return(true) -         
   {                   // return(false)-     ,        start()
//----
    if (_ExpertOrdersTotal == 0 && NewTradeCycleAllowed)                        //  -   OP_BUYSTOP ,
     {                                                                          //      - NewTradeCycleAllowed.... 
      i = _ExpertOrdersTotal; //  , i      ...
      _OrderType      [i] = OP_BUYSTOP; OrderTypeString = "BUYSTOP_ ";
      _OrderLots      [i] = OrderLotsSize;
      _OrderOpenPrice [i] = Ask + OrderLevel*Point;
      _OrderStopLoss  [i] = _OrderOpenPrice[i] - StopLoss*Point;
      //_OrderStopLoss  [i] = Bid;//_OrderOpenPrice[i] - OrderLevel*Point - Spread*Point; //  Bid... 
      _OrderTakeProfit[i] = 0;
      _OrderSend();
      return(true);
     }
 //----
    if (_ExpertOrdersTotal == 1  && _ExpertOrdersStop == 1 && NewTradeCycleAllowed) //  -   OP_SELLSTOP ,
     {                                                                              //      - NewTradeCycleAllowed....
      i = _ExpertOrdersTotal; //  , i    , i-1       ...        
      _OrderType      [i] = OP_SELLSTOP; OrderTypeString = "SELLSTOP_";
      _OrderLots      [i] = OrderLotsSize;
      //_OrderOpenPrice [i] =(_OrderOpenPrice[i-1] - OrderLevel*2*Point - Spread*Point) - OrderLevel*Point; // Bid-OrderLevel*Point
      _OrderOpenPrice [i] = Bid - OrderLevel*Point;
      _OrderStopLoss  [i] = _OrderOpenPrice[i] + StopLoss*Point;
      _OrderTakeProfit[i] = 0;
      _OrderSend(); 
      return(true);
     }
//----
//     ,       -,       - 
//     ...     (NewTradeCycleAllowed),  
//     ,    ....
    if (_ExpertOrdersTotal == 1  && _ExpertOrdersOpen == 1 && NewTradeCycleAllowed)
     {                                                                              
      i = _ExpertOrdersTotal; //  , i    , i-1   ... 
      OrderDirection =  iif(_OrderType[i-1]==OP_SELL,+1,-1); OrderTypeString = iifStr(OrderDirection==+1,"BUYSTOP_ ","SELLSTOP_");                               
      _OrderType      [i] = iif(OrderDirection==+1,OP_BUYSTOP,OP_SELLSTOP);  
      _OrderLots      [i] = OrderLotsSize;                                                               
      _OrderOpenPrice [i] =_OrderStopLoss [i-1]; 
      _OrderStopLoss  [i] =_OrderOpenPrice[i-1]; 
      _OrderTakeProfit[i] = 0;
      _OrderSend(); 
      return(true);
     }
//----

   return(false); //     ,        start()
   }
//+------------------------------------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------------------------------------+
bool _OrderSend()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   _OrderComment   [i] = "Ballistika";
   _OrderTicket[i]=  
        OrderSend(Symbol(),_OrderType      [i]
                          ,_OrderLots      [i]
                          ,_OrderOpenPrice [i] ,3
                          ,_OrderStopLoss  [i]
                          ,_OrderTakeProfit[i]
                          ,_OrderComment   [i]
                          ,MagicNumber,0,CLR_NONE);
   if (_OrderTicket[i] < 0)
    {
     LastError = GetLastError();
     Print(Bl+"("+MagicNumber+")"+OrderTypeString+DoubleToStr(_OrderLots[i],2)+OrderOpenSetErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
    }
   Print(Bl+"("+MagicNumber+")"+OrderTypeString+DoubleToStr(_OrderLots[i],2)+"("+_OrderTicket[i]+")"+OrderOpenSetOkMes);
   PlaySound("ok.wav");
   return(true);
}           
//+----------------------------------------------------------------------------------------------+
//|          :       |
//| - ,  ,            |
//|   -                                                                  |
//| -       TrailingStep  -    |
//+----------------------------------------------------------------------------------------------+
bool OrdersModify()    // return(true) -         
   {                   // return(false)-     ,        start()
//----
//        ,   ,    
//   -  ,  -  ,         TrailingStep
    if (_ExpertOrdersOpen == 1 && _ExpertOrdersStop == 1) 
     {
    //     -     ,   
     i = _ExpertOrdersTotal; //  , i    , i-1   ./. , i-2   ./.  
     j = iif(_OrderType[i-1] == OP_BUY || _OrderType[i-1] == OP_SELL,i-1,i-2); // j -      ...
     k = iif (j == i-1,i-2,i-1);                                               // k -    ...
//      ....     
     if (_OrderOpenPrice [k] != _OrderStopLoss [j]) //  ,     ...
      {
       OrderDirection =  iif(_OrderType[j]==OP_SELL,+1,-1); OrderTypeString = iifStr(OrderDirection==+1,"BUYSTOP_ ","SELLSTOP_");                               
       _OrderLots      [i] = OrderLotsSize;                                                               
       _OrderTicket    [i] = _OrderTicket    [k];
       _OrderOpenPrice [i] = _OrderStopLoss  [j];
       _OrderStopLoss  [i] = _OrderOpenPrice [i] - OrderDirection*(OrderLevel + Spread)*Point;
       _OrderTakeProfit[i] = _OrderTakeProfit[k];
       _OrderModify();
       return(true); 
      }
//      ....     
     OrderDirection      = iif(_OrderType[j]==OP_BUY,+1 , -1); OrderTypeString = iifStr(OrderDirection==+1,"BUY______ ","SELL_____");
     double mprice = iif(OrderDirection ==+1    ,Bid,Ask);
     if ( (OrderDirection * mprice - OrderDirection * _OrderOpenPrice [j])/Point >= TrailingStop)
      if ( (OrderDirection * mprice - OrderDirection * _OrderStopLoss [j])/Point >= TrailingStop + TrailingStep)
       {
        _OrderLots      [i] = OrderLotsSize;                                                               
        _OrderTicket    [i] = _OrderTicket    [j];
        _OrderOpenPrice [i] = _OrderOpenPrice [j];
        _OrderStopLoss  [i] = mprice - OrderDirection * TrailingStop * Point;
        _OrderTakeProfit[i] = _OrderTakeProfit[j];
        _OrderModify();
        return(true); 
       }
      }    
//   ,          ,    
//  -    ...      
//     ,   ,   -       TrailingStep 
    if (_ExpertOrdersTotal == 1 && _ExpertOrdersOpen == 1) 
     {
     i = _ExpertOrdersTotal; //  , i    , i-1    
     OrderDirection      = iif(_OrderType[i-1]==OP_BUY,+1 , -1); OrderTypeString = iifStr(OrderDirection==+1,"BUY______ ","SELL_____");
     //_OrderOpenPrice [i] = iif(OrderDirection ==+1    ,Ask,Bid); // _OrderOpenPrice [i] -     ....
     mprice = iif(OrderDirection ==+1    ,Bid,Ask);
     if ( (OrderDirection * mprice - OrderDirection * _OrderOpenPrice [j])/Point >= TrailingStop)
      if ( (OrderDirection * mprice - OrderDirection * _OrderStopLoss [j])/Point >= TrailingStop + TrailingStep)
      //if ( (OrderDirection * _OrderOpenPrice [i] - OrderDirection * _OrderStopLoss [i-1])/Point >= (OrderLevel + Spread) + TrailingStop + TrailingStep)
      {
       _OrderLots      [i] = OrderLotsSize;                                                               
       _OrderTicket    [i] = _OrderTicket    [i-1];
       _OrderOpenPrice [i] = _OrderOpenPrice [i-1];
       _OrderStopLoss  [i] = mprice - OrderDirection * TrailingStop * Point;
       _OrderTakeProfit[i] = _OrderTakeProfit[i-1];
       _OrderModify();
       return(true); 
      }
     }
//----
   return(false); //     ,        start()
   }
//+--------------------------------------------------------------------+
//|                 |
//|                              |
//+--------------------------------------------------------------------+
bool _OrderModify()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   if (OrderModify(_OrderTicket    [i]
                  ,_OrderOpenPrice [i]
                  ,_OrderStopLoss  [i]
                  ,_OrderTakeProfit[i]
                  ,0
                  ,CLR_NONE))
    {
     Print(Bl+"("+MagicNumber+")"+OrderTypeString+DoubleToStr(_OrderLots[i],2)+"("+_OrderTicket[i]+")"+OrderModifyOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError(); if (LastError == ERR_NO_RESULT) return(true);
     Print(Bl+"("+MagicNumber+")"+OrderTypeString+DoubleToStr(_OrderLots[i],2)+"("+_OrderTicket[i]+")"+OrderModifyErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }           
//+----------------------------------------------------------------------------------------+
//|     ,     |
//|       NewTradeCycleAllowed = false,       |
//|  ,  ,     ,         |
//|    -                                                             |
//+----------------------------------------------------------------------------------------+
bool OrdersDelete()    // return(true) -         
  {                    // return(false)-     ,        start()
//----
   if (_ExpertOrdersOpen == 1 && _ExpertOrdersStop == 1 && ! NewTradeCycleAllowed) //      ...
    {
    //        ...
     i = _ExpertOrdersTotal; //  , i    , i-1   ./. , i-2   ./.  
     j               = iif   (_OrderType[i-1] == OP_BUYSTOP || _OrderType[i-1] == OP_SELLSTOP,i-1,i-2); // j -    ...
     OrderTypeString = iifStr(_OrderType[j  ] == OP_BUYSTOP,"BUYSTOP_ ","SELLSTOP_");                               
     _OrderLots   [i] = OrderLotsSize;                                                               
     _OrderTicket [i] = _OrderTicket [j];
     _OrderDelete();
     return(true); 
    }
   if (_ExpertOrdersTotal != 0 && _ExpertOrdersOpen == 0 && ! NewTradeCycleAllowed) //     ...
    {
     i = _ExpertOrdersTotal; //  , i    , i-1    ... 
     OrderTypeString = iifStr(_OrderType[i-1] == OP_BUYSTOP,"BUYSTOP_ ","SELLSTOP_");                               
     _OrderLots   [i] = OrderLotsSize;                                                               
     _OrderTicket [i] = _OrderTicket [i-1];
     _OrderDelete();
     return(true);  
    }
//----
   return(false); //     ,        start()
  }
//+--------------------------------------------------------------------+
//|                 |
//|                                             |
//+--------------------------------------------------------------------+
bool _OrderDelete()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   if (OrderDelete(_OrderTicket[i]
                   ,CLR_NONE))
    {
     Print(Bl+"("+MagicNumber+")"+OrderTypeString+DoubleToStr(_OrderLots[i],2)+"("+_OrderTicket[i]+")"+OrderDeleteOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError();  
     Print(Bl+"("+MagicNumber+")"+OrderTypeString+DoubleToStr(_OrderLots[i],2)+"("+_OrderTicket[i]+")"+OrderDeleteErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }  
//+----------------------------------------------------------------------------------------------------------------------+
//+-----------------------------------------------------------------------------------------------------+
//|     ,                           |
//|  ,  .  ,                     |
//|     .             |
//|   =  _ExpertOrdersTotal + 1                                                      |
//|           /|
//|                                                                                         |
 //+----------------------------------------------------------------------------------------------------+
//"mailto:komposterius@mail.ru" -   -   
//http://www.mql4.com/ru/users/komposter  
void AllOrdersInit( int magic )
{
   Spread       = MarketInfo(Symbol(),MODE_SPREAD);
	int _GetLastError = 0, _OrdersTotal = OrdersTotal();
	_ExpertOrdersTotal = 0; //   ,  :
   _ExpertOrdersOpen  = 0; //   ,  :
   _ExpertOrdersStop  = 0; //    ,  :
 	//      -  +1
	// ( _OrdersTotal = 0,     1) 
	int temp_value = MathMax( _OrdersTotal+1, 1 );
	ArrayResize( _OrderTicket,			temp_value );
	ArrayResize( _OrderType,			temp_value );
	ArrayResize( _OrderLots,			temp_value );
	ArrayResize( _OrderOpenPrice,		temp_value );
	ArrayResize( _OrderStopLoss,		temp_value );
	ArrayResize( _OrderTakeProfit,	temp_value );
	ArrayResize( _OrderOpenTime,		temp_value );
	ArrayResize( _OrderProfit,			temp_value );
	ArrayResize( _OrderSwap,			temp_value );
	ArrayResize( _OrderCommission,	temp_value );
	ArrayResize( _OrderComment,		temp_value );
	ArrayResize( _OrderExpiration,	temp_value );

	//  
	ArrayInitialize( _OrderTicket,		0 );    
	ArrayInitialize( _OrderType,			0 );
	ArrayInitialize( _OrderLots,			0 );
	ArrayInitialize( _OrderOpenPrice,	0 );
	ArrayInitialize( _OrderStopLoss,		0 );
	ArrayInitialize( _OrderTakeProfit,	0 );
	ArrayInitialize( _OrderOpenTime,		0 );
	ArrayInitialize( _OrderProfit,		0 );
	ArrayInitialize( _OrderSwap,			0 );
	ArrayInitialize( _OrderCommission,	0 );
	ArrayInitialize( _OrderExpiration,	0 );
   
 	for ( int z = 0;  z < _OrdersTotal;  z ++ )
 	{
		if ( !OrderSelect( z, SELECT_BY_POS ) )
		{
			_GetLastError = GetLastError();
			Print("("+MagicNumber+")"+ "OrderSelect( ", z, ", SELECT_BY_POS ) - Error #", _GetLastError );
			continue;
		}
		if ( OrderMagicNumber() == magic && OrderSymbol() == Symbol() )
		{
			//    ,  
			_OrderTicket		[_ExpertOrdersTotal] = OrderTicket();
 			_ExpertOrdersTotal ++;
 	   	switch(OrderType())
           {
            case OP_BUY       : _ExpertOrdersOpen++  ; break; 
            case OP_SELL      : _ExpertOrdersOpen++  ; break;
            case OP_BUYSTOP   : _ExpertOrdersStop++  ; break;
            case OP_SELLSTOP  : _ExpertOrdersStop++  ; break;
           }
		}
	}
	//     - ,   + 
	// ( _ExpertOrdersTotal = 0,     1)
	temp_value = MathMax( _ExpertOrdersTotal+1, 1 );
	ArrayResize( _OrderTicket,			temp_value );
	ArrayResize( _OrderType,			temp_value );
	ArrayResize( _OrderLots,			temp_value );
	ArrayResize( _OrderOpenPrice,		temp_value );
	ArrayResize( _OrderStopLoss,		temp_value );
	ArrayResize( _OrderTakeProfit,	temp_value );
	ArrayResize( _OrderOpenTime,		temp_value );
	ArrayResize( _OrderProfit,			temp_value );
	ArrayResize( _OrderSwap,			temp_value );
	ArrayResize( _OrderCommission,	temp_value );
	ArrayResize( _OrderComment,		temp_value );
	ArrayResize( _OrderExpiration,	temp_value );
	
   ArraySort(_OrderTicket,_ExpertOrdersTotal,0);  //   ...
//------------------------------------------------------------------------------------------------------------------------
	for (   z = 0;  z < _ExpertOrdersTotal;  z ++ )
 	{
		if ( !OrderSelect( _OrderTicket[z], SELECT_BY_TICKET ) )
		{
			_GetLastError = GetLastError();
			Print("("+MagicNumber+")"+ "OrderSelect( ", _OrderTicket[z], ", SELECT_BY_TICKET ) - Error #", _GetLastError );
			continue;
		}
 			//   
 			_OrderType			[z] = OrderType();
			_OrderLots			[z] = NormalizeDouble( OrderLots(), 2 );
			_OrderOpenPrice	[z] = NormalizeDouble( OrderOpenPrice(), Digits );
			_OrderStopLoss		[z] = NormalizeDouble( OrderStopLoss(), Digits );
			_OrderTakeProfit	[z] = NormalizeDouble( OrderTakeProfit(), Digits );
			_OrderOpenTime		[z] = OrderOpenTime();
			_OrderProfit		[z] = NormalizeDouble( OrderProfit(), 2 );
			_OrderSwap			[z] = NormalizeDouble( OrderSwap(), 2 );
			_OrderCommission	[z] = NormalizeDouble( OrderCommission(), 2 );
			_OrderComment		[z] = OrderComment();
			_OrderExpiration	[z] = OrderExpiration();
  	}
//------------------------------------------------------------------------------------------------------------------------   
return;	
}
//------------------------------------------------------------------------------------------------------------------------   

//http://www.mql4.com/ru/users/bstone -  -  ,   (..)
//+------------------------------------------------------------------+
//| helper functions   -                                                |
//+------------------------------------------------------------------+

int sign( double v )
{
    if( v < 0 ) return( -1 );
    return( 1 );
}

//+------------------------------------------------------------------+
double iif( bool condition, double ifTrue, double ifFalse )
{
    if( condition ) return( ifTrue );
    
    return( ifFalse );
}

//+------------------------------------------------------------------+
string iifStr( bool condition, string ifTrue, string ifFalse )
{
    if( condition ) return( ifTrue );

    return( ifFalse );
}

//+------------------------------------------------------------------+
int orderDirection()
{
    return( 1 - 2 * ( OrderType() % 2 ) );
}
//------------------------------------------------------------------------------------------------------------------------   

